Welcome to the Treehouse Community

The Treehouse Community is a meeting place for developers, designers, and programmers of all backgrounds and skill levels to get support. Collaborate here on code errors or bugs that you need feedback on, or asking for an extra set of eyes on your latest project. Join thousands of Treehouse students and alumni in the community today. (Note: Only Treehouse students can comment or ask questions, but non-students are welcome to browse our conversations.)

Looking to learn something new?

Treehouse offers a seven day free trial for new students. Get access to thousands of hours of content and a supportive community. Start your free trial today.

Java Java Objects Harnessing the Power of Objects Handling Exceptions

Muhammad Asif
PLUS
Muhammad Asif
Courses Plus Student 557 Points

Protect the call to kart.drive by handling the IllegalArgumentException that is thrown when not enough battery remains.

i am stucked solving this code would someone help me out

Example.java
class Example {

  public static void main(String[] args) {
    GoKart kart = new GoKart("purple");
    if (kart.isBatteryEmpty()) {
      System.out.println("The battery is empty");
    }
    kart.drive(42);
  }

}
GoKart.java
class GoKart {
  public static final int MAX_BARS = 8;
  private int barCount;
  private String color;
  private int lapsDriven;

  public GoKart(String color) {
    this.color = color;
  }

  public String getColor() {
    return color;
  }

  public void charge() {
    barCount = MAX_BARS;
  }

  public boolean isBatteryEmpty() {
    return barCount == 0;
  }

  public boolean isFullyCharged() {
    return MAX_BARS == barCount;
  }

  public void drive() {
    drive(1);
  }

  public void drive(int laps) {
    if (laps > barCount) {
      throw new IllegalArgumentException("Not enough battery remains");
    }
    lapsDriven += laps;
    barCount -= laps;
  }
 try {
      kart.drive(42); // existing line
    } catch(IllegalArgumentException e) {
      System.out.println(e);
    }    
  }
}

1 Answer

michaelcodes
michaelcodes
5,604 Points

Hello, the try-catch block should be placed in the Example.java file. You have the structure of the try-catch block correctly, it just needs to be wrapped around the kart.drive(42) in Example as such:

class Example {
  public static void main(String[] args) {
    GoKart kart = new GoKart("purple");
    if (kart.isBatteryEmpty()) {
      System.out.println("The battery is empty");
    }
    try {
       kart.drive(42);
    } catch(IllegalArgumentException iae){
        System.out.println(iae);
    }
  }
}

The reason is that the Example.java is the primary file that runs the program, so you want to add the protection to the method call in Example, when the error occurs it will grab the
throw new IllegalArgumentException("Not enough battery remains"); from GoKart.java

Hope this helps!